package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.*;

/**
 * Maske zum Erstellen und ndern von Minen
 */

public class Minengui
    extends Frame {

  // Aufbau der bentigten Datenbankverbindungen
  Sql db = new Sql();
  Sql db2 = new Sql();
  Sql db3 = new Sql();

  int andernid = 0;  // ist die ID des zu ndernden Datensatzes, bei Wert  wird gerade ein neuer Datensatz angelegt
  String altername = new String();

  XYLayout xYLayout1 = new XYLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField tname = new TextField();
  Label label3 = new Label();
  TextField tbild = new TextField();
  Button bsuchen = new Button();

  /**
   * Konstruktor zum Erstellen der Maske fr eine neue Mine
   */

  public Minengui() {
    super("Neue Mine");
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * Konstruktor zum Erstellen der Maske zum ndern einer Mine
   * @param zuandern Name der zu ndernden Mine
   */

  public Minengui(String zuandern) {
    super("Mine ndern");
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    //Auslesen der bisherigen Werte aus der Datenbank
    ResultSet altedaten;
    altedaten = db.select("Select * from mine where name='" + zuandern +
                          "'");

    try {
      altedaten.next();
      label1.setText("Mine ndern");
      beintragen.setLabel("ndern");
      tname.setText(altedaten.getString("name"));
      tbild.setText(altedaten.getString("bild"));
      andernid = altedaten.getInt("mid");
      altername = altedaten.getString("name");
      System.out.println(andernid);
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

    ResultSet sresult, gresult, mresult;
    sresult = db.select("select * from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='" +
                        Editor.getumgebung() + "'");
    gresult = db2.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                         Editor.getumgebung() + "'");

    int i = 0;
    int zaehl = 0;
    int gid;
    try {

      while (gresult.next()) {
        System.out.println(gresult.getString("name"));
        i++;
        zaehl = 0;
        sresult.beforeFirst();
        while (sresult.next()) {
          mresult = db3.select("select * from sensormeldung where mid='" +
                               andernid +
                               "'and gid='" + gresult.getString("gid") +
                               "'and sid='" + sresult.getString("sid") + "'");

          while (mresult.next()) {
            ( (TextField) ergebnisse[i -
             1][zaehl]).setText(mresult.getString("meldung"));
            zaehl++;
          }

        }
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem" + ex);
    }

  }

  // Mainmethode zu Testzwecken
  public static void main(String[] args) {
    Minengui minengui1 = new Minengui("Tretmine");
  }

  Checkbox[][] radios;  //hier kommen die Radiobuttons rein, ber die man die Ergebnisse anklicken kann
  Object[][] ergebnisse; // hier stehen die Textfelder der einzelnen Sensormeldungen drin
  int anzahlgelaende, anzahlebenen;
  private String[] gelaendetypen; // in dies Array kommen die Namen aller Gelndearten
  TextField turl = new TextField();
  Button burlsuchen = new Button();
  Label label4 = new Label();
  Button babbrechen = new Button();
  Button beintragen = new Button();
  Button burleintragen = new Button();

  private void jbInit() throws Exception {
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Neue Mine anlegen");
    this.setLayout(xYLayout1);
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Name:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setText("Bild:");
    tname.setText("");
    tbild.setText("");
    bsuchen.setLabel("Suchen...");
    bsuchen.addActionListener(new Minengui_bsuchen_actionAdapter(this));
    this.setBackground(SystemColor.menu);
    this.setFocusTraversalKeysEnabled(true);
    turl.setText("");
    burlsuchen.addActionListener(new Minengui_burlsuchen_actionAdapter(this));
    burlsuchen.setLabel("Suchen...");

    label4.setText("URL-Suche:");
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        babbrechen_actionPerformed(e);
      }
    });
    beintragen.setLabel("Eintragen");
    beintragen.setVisible(true);
    burleintragen.setLabel("In Zelle schreiben:");
    burleintragen.addActionListener(new Minengui_burleintragen_actionAdapter(this));
    this.add(label1, new XYConstraints(178, 7, 158, 27));
    this.add(label2, new XYConstraints(12, 45, 46, 22));
    this.add(label3, new XYConstraints(193, 45, 31, 22));
    this.add(tname, new XYConstraints(69, 45, 91, 22));
    this.add(tbild, new XYConstraints(231, 45, 104, 22));
    this.add(bsuchen, new XYConstraints(345, 45, 103, 23));
    this.add(turl, new XYConstraints(457, 45, 284, 22));
    this.add(label4, new XYConstraints(457, 18, 70, 22));
    this.add(babbrechen, new XYConstraints(752, 16, 100, 23));
    this.add(beintragen, new XYConstraints(751, 45, 100, 23));
    this.add(burleintragen, new XYConstraints(618, 17, -1, 23));
    this.add(burlsuchen, new XYConstraints(531, 17, 80, 23));

    ResultSet gresult;
    ResultSet sresult;
    // Erstellen der Eingabematrix fr die Sensormeldungen
    sresult = db.select("select * from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='" +
                        Editor.getumgebung() + "'");
    int i = 1;
    anzahlebenen = 0;
    int offset = 100;
    while (sresult.next()) {
      this.add(new Label(sresult.getString("name")),
               new XYConstraints(offset, 70, 50, 20));
      for (int j = 1; j <= sresult.getInt("anzahlebenen"); j++) {
        anzahlebenen++;
        this.add(new Label("Ebene " + j),
                 new XYConstraints(offset, 90, 50, 20));
        offset += 60;
      }
      i++;
    }

    i = 0;
    gresult = db2.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                         Editor.getumgebung() + "'");
    gresult.last();
    anzahlgelaende = gresult.getRow();
    gresult.beforeFirst();
    sresult.beforeFirst();
    gelaendetypen = new String[anzahlgelaende];
    ergebnisse = new Object[anzahlgelaende][anzahlebenen];
    radios = new Checkbox[anzahlgelaende + 1][anzahlebenen + 1];
    CheckboxGroup check = new CheckboxGroup();

    try {
      while (gresult.next()) {
        Label l = new Label(gresult.getString("name"));
        gelaendetypen[i] = gresult.getString("name");
        this.add(l, new XYConstraints(0, i * 20 + 120, 85, 20));
        i++;
        offset = 100;
        sresult.beforeFirst();
        while (sresult.next()) {

          for (int j = 1; j <= sresult.getInt("anzahlebenen"); j++) {
            TextField t = new TextField();
            Checkbox c = new Checkbox("", check, false);
            t.addFocusListener(new FocusListener() {
              public void focusGained(FocusEvent e) {
                TextField t = new TextField();
                t = ( (TextField) e.getSource());
                turl.setText(t.getText());

              }

              public void focusLost(FocusEvent e) {

              }
            });
            radios[i - 1][ (offset - 100) / 60] = c;
            ergebnisse[i - 1][ (offset - 100) / 60] = t;
            this.add(radios[i - 1][ (offset - 100) / 60],
                     new XYConstraints(offset - 10, i * 20 + 100, 10, 20));
            this.add( ( (TextField) ergebnisse[i - 1][ (offset - 100) / 60]),
                     new XYConstraints(offset, i * 20 + 100, 50, 20));
            offset += 60;
          }

        }
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem" + ex);
    }
    offset = 100;
    this.add(new Label("Standard:"),
             new XYConstraints(0, (anzahlgelaende + 1) * 20 + 100, 100, 20));
    for (int j = 0; j < anzahlebenen; j++) {
      Checkbox c = new Checkbox("", check, false);
      radios[anzahlgelaende][ (offset - 100) / 60] = c;
      this.add(radios[anzahlgelaende][ (offset - 100) / 60],
               new XYConstraints(offset + 20, (anzahlgelaende + 1) * 20 + 100,
                                 10, 20));
      offset += 60;

    }

    this.add(new Label("Standard:"),
             new XYConstraints(anzahlebenen * 60 + 100, 80, 100, 20));
    for (int j = 0; j < anzahlgelaende; j++) {
      Checkbox c = new Checkbox("", check, false);
      radios[j][anzahlebenen] = c;
      this.add(radios[j][anzahlebenen],
               new XYConstraints(anzahlebenen * 60 + 115, j * 20 + 125, 20, 10));
    }
    if (160 + anzahlebenen * 60 > 870) {
      xYLayout1.setWidth(160 + anzahlebenen * 60);
    }
    else {
      xYLayout1.setWidth(870);
    }
    if (150 + anzahlgelaende * 20 > 200) {
      xYLayout1.setHeight(150 + anzahlgelaende * 20);
    }
    else {
      xYLayout1.setHeight(200);

    }

    pack();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });
    beintragen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        beintragen_actionPerformed(e);
      }
    });

  }

  void bsuchen_actionPerformed(ActionEvent e) {
    FileDialog d = new FileDialog(this, "Bild ffnen", FileDialog.LOAD);
    d.setFile("*.gif");
    d.setVisible(true);
    tbild.setText(d.getDirectory() + d.getFile());

  }

  void burlsuchen_actionPerformed(ActionEvent e) {
    FileDialog d = new FileDialog(this, "Bild ffnen", FileDialog.LOAD);
    d.setVisible(true);
    turl.setText(d.getDirectory() + d.getFile());
  }

  void babbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    if (tname.getText().equals("") || tbild.getText().equals("")) {
      Warnung w = new Warnung("Bitte vollstndig ausfllen!");
      fehler = true;
    }
    ResultSet nresult;
    nresult = db.select("select name from mine");
    //berprfen ob es den genderten Namen schon gibt
    try {
      if (andernid == 0 || !altername.equals(tname.getText())) {
        while (nresult.next()) {
          if (nresult.getString("name").equals(tname.getText())) {
            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem" + ex);
    }
    if (!fehler) {
      // einfgen, wenn Mine neu angelegt wurde
      if (andernid == 0) {
        db3.mach(
            "insert into mine (name, bild) values ('" +
            tname.getText() +
            "','" + tbild.getText() + "')");
      }
      // wenn gendert wurde werden hier die Werte in der Minentabelle aktuallisiert
      else {
        db3.mach("update mine set name='" + tname.getText() + "',bild='" +
                 tbild.getText() + "' where mid='" + andernid + "'");

        ResultSet sidresult, gidresult;
        sidresult = db3.select("select sid from umgsensorz where uid='" +
                               Editor.getumgebung() + "'");
        gidresult = db2.select("select gid from umggelaendez where uid='" +
                               Editor.getumgebung() + "'");
          // die alten Sensormeldungen werden gelscht und die neuen eingefgt
          try {
          while (sidresult.next()) {
            gidresult.beforeFirst();
            while (gidresult.next()) {

              db.mach("delete from sensormeldung where mid='" + andernid +
                      "' and sid='" + sidresult.getInt("sid") + "'and gid='" +
                      gidresult.getInt("gid") + "'");
            }
          }
        }
        catch (SQLException ex3) {
          System.out.println(ex3);
        }

      }

      ResultSet mresult;
      mresult = db.select("select mid from mine where name='" + tname.getText() +
                          "'");
      try {
        mresult.next();
      }
      catch (SQLException ex) {
        System.out.println("Problem mit mid--Ausslesen:" + ex);
      }
      String mid = new String("doh");
      try {
        mid = mresult.getString("mid");
      }
      catch (SQLException ex1) {
      }
      ResultSet gresult = db2.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                                     Editor.getumgebung() + "'");
      ResultSet sresult = db.select("select * from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='" +
                                    Editor.getumgebung() + "'");
      int i = -1;
      int zaehl = 0;
      try {
        while (gresult.next()) {
          i++;
          sresult.beforeFirst();
          zaehl = 0;
          while (sresult.next()) {
            for (int j = 1; j <= sresult.getInt("anzahlebenen"); j++) {
              db3.mach(
                  "insert into sensormeldung (sid, gid, mid, sensorebene, meldung)values ('" +
                  sresult.getInt("sid") +
                  "','" + gresult.getInt("gid") + "','" + mid + "','" + j +
                  "','" +
                  ( (TextField) ergebnisse[i][zaehl]).getText() + "')");
              zaehl++;

            }

          }
        }
      }
      catch (SQLException ex) {
        System.out.println(ex);
      }

    }
  }

  // eintragen des Wertes des Textfeldes rechts oben in das durch die Checkbox markierte Feld
  void burleintragen_actionPerformed(ActionEvent e) {
    for (int i = 0; i < anzahlebenen; i++) {
      if (radios[anzahlgelaende][i].getState() == true) {
        for (int j = 0; j < anzahlgelaende; j++) {
          ( (TextField) ergebnisse[j][i]).setText(turl.getText());
          ( (TextField) ergebnisse[j][i]).repaint();
        }
      }
      for (int j = 0; j < anzahlgelaende; j++) {
        if (radios[j][anzahlebenen].getState() == true) {
          for (int k = 0; k < anzahlebenen; k++) {
            ( (TextField) ergebnisse[j][k]).setText(turl.getText());
            ( (TextField) ergebnisse[j][k]).repaint();
          }
        }

        if (radios[j][i].getState() == true) {
          ( (TextField) ergebnisse[j][i]).setText(turl.getText());
          ( (TextField) ergebnisse[j][i]).repaint();
        }
      }
    }
  }

}

class Minengui_bsuchen_actionAdapter
    implements java.awt.event.ActionListener {
  Minengui adaptee;

  Minengui_bsuchen_actionAdapter(Minengui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bsuchen_actionPerformed(e);
  }
}

class Minengui_burlsuchen_actionAdapter
    implements java.awt.event.ActionListener {
  Minengui adaptee;

  Minengui_burlsuchen_actionAdapter(Minengui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.burlsuchen_actionPerformed(e);
  }
}

class Minengui_burleintragen_actionAdapter
    implements java.awt.event.ActionListener {
  Minengui adaptee;

  Minengui_burleintragen_actionAdapter(Minengui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.burleintragen_actionPerformed(e);
  }
}
