package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.SQLException;
import java.sql.ResultSet;

/**
 * Maske fr das Anlegen und ndern von Umgebungen
 */
public class Umgebunganlegengui
    extends Frame {
  int andernid = 0;
  String altername = new String();
  int anzahlgelaende = 0;
  int anzahlminen = 0;
  int anzahlroboter = 0;
  int anzahlsensoren = 0;
  int anzahlantriebe = 0;
  Checkbox[] gelaende, minen, roboter, sensoren, antriebe;
  int[] gelaendeids, minenids, roboterids, sensorenids, antriebeids;

  Sql db = new Sql();

  Label label1b = new Label();
  Choice czuaendern = new Choice();
  Button babbruch = new Button();
  Button baendern = new Button();

  XYLayout xYLayout1 = new XYLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField tname = new TextField();
  Button babbrechen = new Button();
  Button beintragen = new Button();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label6 = new Label();
  Label label7 = new Label();
  /**
   * Konstruktor fr die Maske einer neuen Umgebung
   */
  public Umgebunganlegengui() {
    super("Umgebung anlegen!");
    this.setLayout(xYLayout1);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
 /**
  * Konstruktor fr eine GUI fr die Auswahl welche Umgebung gendert werden soll
  * @param aendern sollte true sein
  */
  public Umgebunganlegengui(boolean aendern) {
    super("Umgebung ndern!");
    label1b.setFont(new java.awt.Font("Dialog", 1, 15));
    label1b.setText("Umgebung ndern");
    this.setLayout(xYLayout1);
    babbruch.setLabel("Abbrechen");

    baendern.setLabel("ndern");
    xYLayout1.setWidth(400);
    xYLayout1.setHeight(207);
    this.add(label1b, new XYConstraints(131, 14, 138, 25));
    this.add(czuaendern, new XYConstraints(96, 77, 209, 20));
    this.add(babbruch, new XYConstraints(96, 120, 99, 31));
    this.add(baendern, new XYConstraints(206, 120, 99, 31));
    babbruch.addActionListener(new abbruchListener());
    baendern.addActionListener(new aendernListener());

    ResultSet result = db.select("select uname from umgebung");
    try {
      while (result.next()) {
        czuaendern.add(result.getString("uname"));
      }
    }
    catch (SQLException ex) {
    }
    pack();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });

  }
 /**
  * Konstruktor fr eine Maske zur nderung einer Umgebung
  * @param zuandern Name der zu ndernden Umgebung
  */
  public void Umgebunganlegen(String zuandern) {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    label1.setText("Umgebung ndern!");
    beintragen.setLabel("ndern");
    //auslesen der vorhandenen Werte aus der Datenbank uns Schreiben ins Formular
    ResultSet result = db.select("select * from umgebung where uname='" +
                                 zuandern + "'");
    try {
      result.next();
      andernid = result.getInt("uid");
      altername = result.getString("uname");
      tname.setText(altername);
      result = db.select("select gid from umggelaendez where uid='" + andernid +
                         "'");
      while (result.next()) {

        for (int i = 0; i < anzahlgelaende; i++) {
          if (result.getInt("gid") == gelaendeids[i]) {
            gelaende[i].setState(true);
            i = anzahlgelaende;
          }
        }
      }

      result = db.select("select aid from umgantriebz where uid='" + andernid +
                         "'");
      while (result.next()) {

        for (int i = 0; i < anzahlantriebe; i++) {
          if (result.getInt("aid") == antriebeids[i]) {
            antriebe[i].setState(true);
            i = anzahlantriebe;
          }
        }
      }

      result = db.select("select rid from umgroboterz where uid='" + andernid +
                         "'");
      while (result.next()) {

        for (int i = 0; i < anzahlroboter; i++) {
          if (result.getInt("rid") == roboterids[i]) {
            roboter[i].setState(true);
            i = anzahlroboter;
          }
        }
      }

      result = db.select("select sid from umgsensorz where uid='" + andernid +
                         "'");
      while (result.next()) {

        for (int i = 0; i < anzahlsensoren; i++) {
          if (result.getInt("sid") == sensorenids[i]) {
            sensoren[i].setState(true);
            i = anzahlsensoren;
          }
        }
      }

      result = db.select("select mid from umgminez where uid='" + andernid +
                         "'");
      while (result.next()) {

        for (int i = 0; i < anzahlminen; i++) {
          if (result.getInt("mid") == minenids[i]) {
            minen[i].setState(true);
            i = anzahlminen;
          }
        }
      }

    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

  }
 //Mainmethode zu Testzwecken
  public static void main(String[] args) {
    Umgebunganlegengui umgebunganlegengui1 = new Umgebunganlegengui();
    Frame f = new Frame();
  }

  private void jbInit() throws Exception {
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Umgebung anlegen");

    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Name:");
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new
                                 Umgebunganlegengui_babbrechen_actionAdapter(this));
    tname.setText("");
    beintragen.setLabel("Eintragen");
    beintragen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        beintragen_actionPerformed(e);
      }
    });
    label3.setText("Gelnde:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label4.setText("Minen:");
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    label5.setText("Roboter:");
    label5.setFont(new java.awt.Font("Dialog", 0, 13));
    label6.setText("Sensoren:");
    label6.setFont(new java.awt.Font("Dialog", 0, 13));
    label7.setText("Antriebe:");
    label7.setFont(new java.awt.Font("Dialog", 0, 13));
    this.setBackground(SystemColor.menu);
    this.add(label1, new XYConstraints(164, 19, 149, 30));
    this.add(label2, new XYConstraints(13, 67, 51, 23));
    this.add(tname, new XYConstraints(63, 67, 129, 27));
    this.add(beintragen, new XYConstraints(355, 67, 105, 28));
    this.add(label7, new XYConstraints(370, 113, 57, 23));
    this.add(label5, new XYConstraints(190, 113, 51, 23));
    this.add(label4, new XYConstraints(100, 113, 51, 23));
    this.add(label3, new XYConstraints(10, 113, 64, 23));
    this.add(babbrechen, new XYConstraints(225, 67, 105, 28));
    this.add(label6, new XYConstraints(280, 113, 68, 23));

    int i = 0;
    ResultSet result;
    result = db.select("select * from gelaende");
    result.last();
    anzahlgelaende = result.getRow();
    gelaende = new Checkbox[anzahlgelaende];
    result.beforeFirst();
    gelaendeids = new int[anzahlgelaende];

    while (result.next()) {
      Checkbox c = new Checkbox("", false);
      gelaende[i] = c;
      Label l = new Label(result.getString("name"));
      gelaendeids[i] = result.getInt("gid");
      System.out.println(l.getText() + gelaendeids[i]);
      this.add(l, new XYConstraints(25, 140 + i * 20, 70, 20));
      this.add(c, new XYConstraints(10, 140 + i * 20, 20, 20));
      i++;
    }

    i = 0;
    result = db.select("select * from mine");
    result.last();
    anzahlminen = result.getRow();
    minen = new Checkbox[anzahlminen];
    result.beforeFirst();
    minenids = new int[anzahlminen];

    while (result.next()) {
      Checkbox c = new Checkbox("", false);
      minen[i] = c;
      Label l = new Label(result.getString("name"));
      minenids[i] = result.getInt("mid");
      this.add(l, new XYConstraints(115, 140 + i * 20, 70, 20));
      this.add(c, new XYConstraints(100, 140 + i * 20, 20, 20));
      i++;
    }

    i = 0;
    result = db.select("select * from roboter");
    result.last();
    anzahlroboter = result.getRow();
    roboter = new Checkbox[anzahlroboter];
    result.beforeFirst();
    roboterids = new int[anzahlroboter];

    while (result.next()) {
      Checkbox c = new Checkbox("", false);
      roboter[i] = c;
      Label l = new Label(result.getString("name"));
      roboterids[i] = result.getInt("rid");
      this.add(l, new XYConstraints(205, 140 + i * 20, 70, 20));
      this.add(c, new XYConstraints(190, 140 + i * 20, 20, 20));
      i++;
    }

    i = 0;
    result = db.select("select * from sensor");
    result.last();
    anzahlsensoren = result.getRow();
    sensoren = new Checkbox[anzahlsensoren];
    result.beforeFirst();
    sensorenids = new int[anzahlsensoren];

    while (result.next()) {
      Checkbox c = new Checkbox("", false);
      Label l = new Label(result.getString("name"));
      sensoren[i] = c;
      sensorenids[i] = result.getInt("sid");
      this.add(l, new XYConstraints(295, 140 + i * 20, 70, 20));
      this.add(c, new XYConstraints(280, 140 + i * 20, 20, 20));
      i++;
    }

    i = 0;
    result = db.select("select * from antrieb");
    result.last();
    anzahlantriebe = result.getRow();
    antriebe = new Checkbox[anzahlantriebe];
    result.beforeFirst();
    antriebeids = new int[anzahlantriebe];

    while (result.next()) {
      Checkbox c = new Checkbox("", false);
      Label l = new Label(result.getString("name"));
      antriebe[i] = c;
      antriebeids[i] = result.getInt("aid");
      this.add(l, new XYConstraints(385, 140 + i * 20, 70, 20));
      this.add(c, new XYConstraints(370, 140 + i * 20, 20, 20));
      i++;
    }
    int maxheight = 0;
    if (maxheight < anzahlgelaende) {
      maxheight = anzahlgelaende;
    }
    if (maxheight < anzahlminen) {
      maxheight = anzahlminen;
    }
    if (maxheight < anzahlroboter) {
      maxheight = anzahlroboter;
    }
    if (maxheight < anzahlsensoren) {
      maxheight = anzahlsensoren;
    }
    if (maxheight < anzahlantriebe) {
      maxheight = anzahlantriebe;

    }
    xYLayout1.setWidth(498);
    xYLayout1.setHeight(maxheight * 20 + 140);

    pack();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });

    //pack();
    setVisible(false);
    setVisible(true);

  }

  void babbrechen_actionPerformed(ActionEvent e) {
    dispose();

  }

  void babbruch_actionPerformed(ActionEvent e) {
    dispose();
  }

  void baendern_actionPerformed(ActionEvent e) {
    removeAll();
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    ResultSet result;

    result = db.select("select uname from umgebung");

    try {
      if (andernid == 0 || !altername.equals(tname.getText())) {
        while (result.next()) {
          if (result.getString("uname").equals(tname.getText())) {
            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }
    if (tname.getText().equals("")) {
      Warnung w = new Warnung("Bitte Name angeben!");
      fehler = true;
    }
    System.out.println(fehler);

    if (!fehler) {
      if (andernid == 0) {
        db.mach("insert into umgebung (uname,aktiv) values ('" + tname.getText() +
                "','false')");
      }
      else {
        db.mach("update umgebung set uname ='" + tname.getText() +
                "' where uid='" + andernid + "'");
        db.mach("delete from umgroboterz where uid='" + andernid + "'");
        db.mach("delete from umgantriebz where uid='" + andernid + "'");
        db.mach("delete from umgsensorz where uid='" + andernid + "'");
        db.mach("delete from umgminez where uid='" + andernid + "'");
        db.mach("delete from umggelaendez where uid='" + andernid + "'");
      }

      int uid = 0;
      result = db.select("select uid from umgebung where uname='" +
                         tname.getText() + "'");
      try {
        result.next();
        uid = result.getInt("uid");
      }
      catch (SQLException ex1) {
      }
      for (int i = 0; i < anzahlgelaende; i++) {
        if (gelaende[i].getState()) {
          db.mach("insert into umggelaendez (gid, uid) values ('" +
                  gelaendeids[i] + "','" + uid + "')");
        }
      }

      for (int i = 0; i < anzahlminen; i++) {
        if (minen[i].getState()) {
          db.mach("insert into umgminez (mid, uid) values ('" +
                  minenids[i] + "','" + uid + "')");
        }
      }

      for (int i = 0; i < anzahlroboter; i++) {
        if (roboter[i].getState()) {
          db.mach("insert into umgroboterz (rid, uid) values ('" +
                  roboterids[i] + "','" + uid + "')");
        }
      }

      for (int i = 0; i < anzahlsensoren; i++) {
        if (sensoren[i].getState()) {
          db.mach("insert into umgsensorz (sid, uid) values ('" +
                  sensorenids[i] + "','" + uid + "')");
        }
      }

      for (int i = 0; i < anzahlantriebe; i++) {
        if (antriebe[i].getState()) {
          db.mach("insert into umgantriebz (aid, uid) values ('" +
                  antriebeids[i] + "','" + uid + "')");
        }
      }

    }

  }

  class abbruchListener
      implements java.awt.event.ActionListener {
    public void actionPerformed(ActionEvent e) {
      dispose();

    }

  }

  class aendernListener
      implements java.awt.event.ActionListener {
    public void actionPerformed(ActionEvent e) {
      removeAll();
      Umgebunganlegen(czuaendern.getSelectedItem());
    }
  }
}

class Umgebunganlegengui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Umgebunganlegengui adaptee;

  Umgebunganlegengui_babbrechen_actionAdapter(Umgebunganlegengui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}