package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.ResultSet;
import java.sql.*;
/**
 * Maske fr das ndern und Anlegen von Gelndearten
 */
public class Gelaendegui
    extends Frame {
  int andernid;
  String altername = new String();
  Checkbox[] radios;
  TextField[] ergebnisse; //Textfelder der Sensormeldungen
  int anzahlebenen;

  // Herstellen der bentigten Datenbankanbinungen
  Sql db = new Sql();
  Sql db2 = new Sql();

  XYLayout xYLayout1 = new XYLayout();
  Button beintragen = new Button();
  Button babbrechen = new Button();
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label7 = new Label();
  Label label8 = new Label();
  Label label9 = new Label();
  TextField tname = new TextField();
  TextField tbild = new TextField();
  TextField tlaenge = new TextField();
  TextField tbreite = new TextField();
  Label label10 = new Label();
  Label label11 = new Label();
  Button bdurchsuchen = new Button();
  Choice choehe = new Choice();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label6 = new Label();
  Button burleintragen = new Button();
  Button burlsuchen = new Button();
  TextField turl = new TextField();

  /**
   * Konstruktor stt das Erzeugen der Maske an
   * Dieser Konstruktor wird beim Erstellen eines neuen Gelndes aufgerufen
   */

  public Gelaendegui() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * Konstruktor fr das ndern eines Gelndes
   * @param zuandern Name des zu ndernden Gelndes
   */
  public Gelaendegui(String zuandern) {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    ResultSet altedaten;
    // Auslesen der bisherigen Daten aus der Datenbank und Schreiben in die Maske
    altedaten = db.select("Select * from gelaende where name='" + zuandern +
                          "'");
    try {
      altedaten.next();
      tbild.setText(altedaten.getString("bild"));
      tname.setText(altedaten.getString("name"));
      altername = tname.getText();
      tlaenge.setText(altedaten.getString("laenge"));
      tbreite.setText(altedaten.getString("breite"));
      choehe.select(altedaten.getString("hoehe"));
      beintragen.setLabel("ndern");
      label9.setText("Gelnde ndern");
      andernid = altedaten.getInt("gid");
      ResultSet result;
      result=db.select("select sensor.sid from sensor, umgsensorz where sensor.sid=umgsensorz.sid and uid ='"+Editor.getumgebung()+"'");
      result.next();
      altedaten = db.select("Select * from sensormeldung where gid='" +
                            andernid +
                            "'and mid='0'and sid='"+result.getString("sid")+"'");
      int i = 0;
      while (altedaten.next()) {
        ( (TextField) (ergebnisse[i])).setText(altedaten.getString(
            "meldung"));
        i++;
      }
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

  }

  private void jbInit() throws Exception {

    this.setLayout(xYLayout1);
    beintragen.setLabel("Eintragen");
    beintragen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        beintragen_actionPerformed(e);
      }
    });
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new Gelaendegui_babbrechen_actionAdapter(this));
    label1.setFont(new java.awt.Font("Dialog", 0, 13));
    label1.setText("Name:");
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Bild:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setText("Hhe:");
    label7.setFont(new java.awt.Font("Dialog", 0, 13));
    label7.setText("Lnge:");
    label8.setFont(new java.awt.Font("Dialog", 0, 13));
    label8.setText("Breite:");
    label9.setFont(new java.awt.Font("Dialog", 1, 15));
    label9.setText("Neue Gelndeart anlegen");
    tlaenge.setText("1");
    tbreite.setText("1");
    tbild.setText("");
    tname.setText("");
    label10.setFont(new java.awt.Font("Dialog", 0, 13));
    label10.setText("Kachel(n)");
    label11.setFont(new java.awt.Font("Dialog", 0, 13));
    label11.setText("Kachel(n)");
    bdurchsuchen.setLabel("Durchsuchen...");
    bdurchsuchen.addMouseListener(new Gelaendegui_bdurchsuchen_mouseAdapter(this));

    this.setBackground(SystemColor.control);
    this.setResizable(false);

    label4.setText("Sensor:");
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    label5.setText("Ebene:");
    label5.setFont(new java.awt.Font("Dialog", 0, 13));
    label6.setText("Meldung:");
    label6.setFont(new java.awt.Font("Dialog", 0, 13));

    burleintragen.setLabel("In Zelle schreiben:");
    burleintragen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        burleintragen_actionPerformed(e);
      }
    });
    burlsuchen.setLabel("Pfadsuche...");
    burlsuchen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        burlsuchen_actionPerformed(e);
      }
    });

    turl.setText("");
    this.add(label1, new XYConstraints(30, 38, 46, 30));
    this.add(label2, new XYConstraints(30, 68, 40, 30));
    this.add(tname, new XYConstraints(75, 44, 113, 19));
    this.add(tbild, new XYConstraints(75, 74, 113, 19));
    this.add(label3, new XYConstraints(30, 135, 42, 30));
    this.add(choehe, new XYConstraints(75, 140, 49, 21));
    this.add(bdurchsuchen, new XYConstraints(75, 97, 117, 24));
    this.add(label7, new XYConstraints(30, 170, 41, 30));
    this.add(label8, new XYConstraints(30, 200, 43, 30));
    this.add(tlaenge, new XYConstraints(75, 177, 27, 19));
    this.add(tbreite, new XYConstraints(75, 207, 27, 19));
    this.add(label11, new XYConstraints(118, 177, 65, 25));
    this.add(label10, new XYConstraints(118, 206, 65, 25));
    this.add(label6, new XYConstraints(378, 94, 59, 30));
    this.add(burleintragen, new XYConstraints(312, 44, 125, 23));
    this.add(turl, new XYConstraints(208, 74, 229, 19));
    this.add(burlsuchen, new XYConstraints(208, 44, 98, 23));
    this.add(label4, new XYConstraints(208, 94, 46, 30));
    this.add(label9, new XYConstraints(133, 5, -1, 30));
    this.add(label5, new XYConstraints(271, 94, 46, 30));
    this.add(beintragen, new XYConstraints(41, 323, 117, -1));
    this.add(babbrechen, new XYConstraints(41, 356, 117, -1));
    choehe.add("0");
    choehe.add("1");
    choehe.add("2");
    ResultSet sresult;
    sresult = db.select("select * from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='"+Editor.getumgebung()+"'");
    int i = 1;
    anzahlebenen = 0;
    int offset = 130;
    // Aufbau der Maske mit einer Zeile fr jede Ebene jedes Sensors bei Rckgabewert und Durchsichtigkeit
    while (sresult.next()) {
      this.add(new Label(sresult.getString("name")),
               new XYConstraints(208, offset, 50, 20));
      for (int j = 1; j <= sresult.getInt("anzahlebenen"); j++) {
        anzahlebenen++;
        this.add(new Label("Ebene " + j),
                 new XYConstraints(271, offset, 50, 20));
        offset += 20;
      }
      i++;
    }
    xYLayout1.setWidth(513);
    if (150+anzahlebenen*20>400) xYLayout1.setHeight(150+anzahlebenen*20);
    else xYLayout1.setHeight(400);

    i = 0;
    sresult.beforeFirst();

    ergebnisse = new TextField[anzahlebenen];
    radios = new Checkbox[anzahlebenen + 1];
    CheckboxGroup check = new CheckboxGroup();

    for (int j = 0; j < anzahlebenen; j++) {
      offset = 130;
      radios[j] = new Checkbox("", check, false);
      TextField t = new TextField();
      t.addFocusListener(new FocusListener() {
        public void focusGained(FocusEvent e) {
          TextField t = new TextField();
          t = ( (TextField) e.getSource());
          turl.setText(t.getText());
        }

        public void focusLost(FocusEvent e) {
        }
      });

      ergebnisse[j] = t;
      this.add(radios[j], new XYConstraints(340, offset + j * 20, 20, 20));
      this.add(ergebnisse[j], new XYConstraints(370, offset + j * 20, 70, 20));
      offset += 20;
    }
    radios[anzahlebenen] = new Checkbox("", check, false);
    this.add(radios[anzahlebenen],
             new XYConstraints(400, offset + (anzahlebenen - 1) * 20, 20, 20));

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });

    setTitle("Gelnde anlegen");
    pack();
    setVisible(true);
  }

  void babbrechen_actionPerformed(ActionEvent e) {
    this.setVisible(false);
    this.dispose();
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    //berprfung der eingegebenen Werte
    if (tname.getText().equals("") || tbild.getText().equals("") ||
        tlaenge.getText().equals("") || tbreite.getText().equals("") || !tlaenge.getText().matches("[\\d]*") || !tbreite.getText().matches("[\\d]*")) {
      Warnung w = new Warnung("Bitte vollstndig und gltig ausfllen!");
      fehler = true;
    }
    ResultSet result;

    result = db.select("select name from gelaende");

    try {
      if (andernid == 0 || !altername.equals(tname.getText())) {
        while (result.next()) {
          if (result.getString("name").equals(tname.getText())) {
            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem");
    }

    if (!fehler) {
      //wenn ein neuer Wert angelegt werden soll wird dies nun getan
      if (andernid == 0) {
        String stmt = new String(
            "insert into gelaende (name, bild, hoehe, laenge, breite) values" +
            "('" + tname.getText() + "', '" + tbild.getText() +
            "', '" + choehe.getSelectedItem() + "', '" +
            tlaenge.getText() + "','" + tbreite.getText() +
            "') ");
        db.mach(stmt);
      }
      result = db.select("Select gid from gelaende where name='" +
                         tname.getText() +
                         "'");
      int gid = 0;
      try {
        result.next();
        gid = result.getInt("gid");
      }
      catch (SQLException ex2) {
      }
      //soll ein Wert gendert werden, wird hier die Gelndetabelle auf den aktuellen Stand gebracht
      if(andernid!=0){
        String stmt = new String("update gelaende set name='" + tname.getText() +
                                 "', bild='" + tbild.getText() + "', hoehe='" +
                                 choehe.getSelectedItem() + "', laenge='" +
                                 tlaenge.getText() + "', breite='" +
                                 tbreite.getText() + "'where gid='" + gid + "'");
        db.mach(stmt);
      }

      // wenn ein Gelnde gendert werden sollte werden die alten Datenstze aus der Datenbank gelscht
      //(nur die Datenstze der aktuellen Umgebung, da nur sie auch in der Eingabemaske stehen)
      if (andernid != 0) {
        ResultSet sidresult;
        sidresult= db.select("select sid from umgsensorz where uid='"+Editor.getumgebung()+"'");
        try {
          while (sidresult.next()) {
            db2.mach("delete from sensormeldung where gid='" + andernid +
                    "'and mid='0'and sid=' " + sidresult.getInt("sid") +"'");
          }
        }
        catch (SQLException ex3) {
          System.out.println(ex3);
        }
        gid = andernid;
      }

      ResultSet sresult = db.select("select * from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='"+Editor.getumgebung()+"'");

      int i = -1;
      i++;
      try {
        sresult.beforeFirst();
        int zaehl = 0;
        //eintragen der Sensormeldungen und Durchsichtigkeitswerte
        while (sresult.next()) {
          for (int j = 1; j <= sresult.getInt("anzahlebenen"); j++) {
            db2.mach(
                "insert into sensormeldung (sid, gid, mid, sensorebene, meldung)values ('" +
                sresult.getInt("sid") +
                "','" + gid + "','0','" + j + "','" +
                ergebnisse[zaehl].getText() + "')");
            zaehl++;
          }
        }
      }
      catch (SQLException ex1) {
        System.out.println(ex1);
      }

    }
  }

    //Mainmethode zu Testzwecken
  public static void main(String args[]) {
    Gelaendegui g = new Gelaendegui("Meer");
  }

  void bdurchsuchen_mouseClicked(MouseEvent e) {
    FileDialog d = new FileDialog(this, "Bild ffnen", FileDialog.LOAD);
    d.setFile("*.gif");
    d.setVisible(true);
    tbild.setText(d.getDirectory() + d.getFile());

  }

  void burlsuchen_actionPerformed(ActionEvent e) {
    FileDialog d = new FileDialog(this, "Bild ffnen", FileDialog.LOAD);
    d.setVisible(true);
    turl.setText(d.getDirectory() + d.getFile());

  }

  void burleintragen_actionPerformed(ActionEvent e) {
    for (int i = 0; i < anzahlebenen; i++) {

      if (radios[anzahlebenen].getState() == true) {
        for (int k = 0; k < anzahlebenen; k++) {
          ( (TextField) ergebnisse[k]).setText(turl.getText());
          ( (TextField) ergebnisse[k]).repaint();
        }
      }

      if (radios[i].getState() == true) {
        ( (TextField) ergebnisse[i]).setText(turl.getText());
        ( (TextField) ergebnisse[i]).repaint();
      }

    }

  }
}

class Gelaendegui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Gelaendegui adaptee;

  Gelaendegui_babbrechen_actionAdapter(Gelaendegui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class Gelaendegui_beintragen_actionAdapter
    implements java.awt.event.ActionListener {
  Gelaendegui adaptee;

  Gelaendegui_beintragen_actionAdapter(Gelaendegui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.beintragen_actionPerformed(e);
  }
}

class Gelaendegui_bdurchsuchen_mouseAdapter
    extends java.awt.event.MouseAdapter {
  Gelaendegui adaptee;

  Gelaendegui_bdurchsuchen_mouseAdapter(Gelaendegui adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.bdurchsuchen_mouseClicked(e);
  }
}
